// --- MAIN.CPP
#include <windows.h>   //Windows-Funktionen
#include <stdio.h>	   //sprintf()...

#include "main.h"


#define  ID_TIMER	1


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{

	MSG msg;
	WNDCLASS wc;

	//Hauptfenster:
	wc.cbClsExtra=0;
	wc.cbWndExtra=0;
	wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.hCursor=LoadCursor(NULL, IDC_ARROW);
	wc.hIcon=LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON));
	wc.hInstance=hInstance;
	wc.lpfnWndProc=WndProc;
	wc.lpszClassName=name;
	wc.lpszMenuName="menu";
	wc.style=CS_HREDRAW | CS_VREDRAW;

	RegisterClass(&wc);

	//Statusfenster:
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.hIcon = NULL;
	wc.lpfnWndProc = ChildProc;
	wc.lpszClassName = ChildName;

	RegisterClass(&wc);

	//Schussfenster:
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.hIcon = NULL;
	wc.lpfnWndProc = KreisProc;
	wc.lpszClassName = KreisName;

	RegisterClass(&wc);


	hWnd=CreateWindow(name, name, WS_POPUP, CW_USEDEFAULT, CW_USEDEFAULT, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), NULL, NULL, hInstance, NULL);

	ShowWindow(hWnd, iCmdShow);
	UpdateWindow(hWnd);

	while(obBeenden == false) //solange Programm nicht beendet werden soll...
	{
		//WindowMessages fuer Programm abrufen:
		while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		}


		if(mc.get_obMonte() == true)	//Wenn Monte-Carlo-Simulation durchgefuehrt wird...
		{
			mc.ShootPoint(koerper);		//Punkt schiessen

			//Farbe veraendern:
			a+=3; if(a>MAX_COLOR) {a=0; b+=3;} if(b>MAX_COLOR) {b=0; c+=3;} if(c>MAX_COLOR) {c=0;}


			InvalidateRect(hKreis, 0, 0);	//Punkt zeichnen
			
			if(mc.get_obAuto() == true)		//Wenn n ueber Varianz zu bestimmen...
			{
				mc.Wahrscheinlichkeit();	//...Wahrscheinlichkeit berechnen
				mc.Varianz();				//...Varianz berechnen
				
				//Wenn Varianz kleiner Abbruchwert und n groesser Mindestanzahl:
				if((mc.getVarianz() < mc.getEPS() )&&(mc.get_n() > mc.getNMIN() ))
				{
					mc.EndMC(pi);	//...Simulation beenenden
				}
			}
			else	//Wenn n durch Benutzer festgelegt:
			{
				//...wenn n durch Benutzer definierten Abbruchwert ueberschreitet:
				if(mc.get_n() >= mc.getNumberOfDots() )
				{
					mc.EndMC(pi);	//...Simulation beenden
				}
			}
		}

	}

	return msg.wParam;
};


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	RECT rect;

	if(message == WM_CREATE)
	{
		GetClientRect(hWnd, &rect);

		//Childwindows erstellen:
		hChild = CreateWindow(ChildName, NULL, WS_CHILD|WS_VISIBLE, rect.right-(int)(rect.right/2.5), 0, rect.right, rect.bottom, hWnd, NULL, ((LPCREATESTRUCT) lParam)->hInstance, NULL);
		hKreis = CreateWindow(KreisName, NULL, WS_CHILD|WS_VISIBLE, rect.left, 0, rect.right-(int)(rect.right/2.5), rect.bottom, hWnd, NULL, ((LPCREATESTRUCT) lParam)->hInstance, NULL);

		//Timer fuer Statusfenster setzen:
		SetTimer(hChild, ID_TIMER, 50, NULL);
	}

	if (message==WM_DESTROY)
	{
		obBeenden = true;	//Hauptschleife beenden
		PostQuitMessage(0);
	}

	
	if(message==WM_COMMAND) //Men
	{
		switch(LOWORD(wParam))
		{
		case(beenden): //Wenn "Beenden" gedrckt: Sende Nachricht "WM_DESTROY"
			SendMessage(hWnd, WM_DESTROY, 0,0);
			break;
		
		case(einstellungen): //Wenn "Einstellungen": Einstellungs-Dialog ffnen
			DialogBox(hInstance, "IDD_SETTINGS", hWnd, DialogProcSettings);
			InvalidateRect(hWnd, 0, 1);
			break;

		case(about): //about-Dialog
			DialogBox(hInstance, "IDD_ABOUT", hWnd, DialogProcOK);
			break;

		case(start): //Monte-Carlo Simulation starten
			mc.StartMC();		
			break;
		case(stop): //Monte-Carlo Simulation stoppen
			mc.EndMC(pi);
			InvalidateRect(hKreis, 0, 1);
			InvalidateRect(hChild, 0, 1);
			break;

		case(out):
			ausgabe.speichern(koerper.getRadius(),
							  koerper.getDimensionen(),
							  koerper.getFlaeche(),
							  mc.get_n(),
							  mc.get_m(),
							  mc.get_p(),
							  mc.getVarianz(),
							  pi.getPI(),
							  true
							 );
			MessageBox(hWnd, "Auswertung in Datei 'mc_result.txt' gespeichert.", "Ergebnis gespeichert.", MB_ICONINFORMATION|MB_OK);
			break;
		}
			
	}	

return DefWindowProc(hWnd, message, wParam, lParam);
};



LRESULT CALLBACK KreisProc(HWND hKreis, UINT messageKreis, WPARAM wParam, LPARAM lParam)
{
	HDC hdcKreis;
	PAINTSTRUCT psKreis;
	
	if(messageKreis == WM_PAINT)
	{
		hdcKreis=BeginPaint(hKreis, &psKreis);

		if(mc.get_obMonte() == true)	//Wenn Simulation laeuft:
		{
			//...den aktuellen Punkte zeichnen (zweidimensional):
			SetPixel(hdcKreis,
					 koerper.DotToClient( mc.getX() ),
					 koerper.DotToClient( mc.getY() ),
					 RGB(a, b, c)
					);
		}
		else	//Wenn Simulation nicht laeuft:
		{
			//Rechteck und Kreis zeichnen:

			Rectangle(hdcKreis,	//Begrenzungsflaeche
					  koerper.getRandabstand(),							//xTop
					  koerper.getRandabstand(),							//yTop
					  koerper.getRandabstand() + koerper.getSeiteA(),	//xBottom
					  koerper.getRandabstand() + koerper.getSeiteA()	//yBottom
					 );

			Ellipse  (hdcKreis,	//Kreis innerhalb Begrenzungskoerper
				   	  koerper.getRandabstand(),
					  koerper.getRandabstand() + koerper.getSeiteA(),
					  koerper.getRandabstand() + koerper.getSeiteA(),
					  koerper.getRandabstand()
				     );
		}

		EndPaint(hKreis, &psKreis);
	}
return DefWindowProc(hKreis, messageKreis, wParam, lParam);
}



LRESULT CALLBACK ChildProc(HWND hChild, UINT messageChild, WPARAM wParam, LPARAM lParam)
{
	HDC hdcChild;
	PAINTSTRUCT psChild;
	TEXTMETRIC tm;
	const int rand	= 10;

	//Textausgabe:
	if(messageChild == WM_PAINT)
	{
		hdcChild = BeginPaint(hChild, &psChild);

		GetTextMetrics(hdcChild, &tm);
		cyChar = tm.tmHeight + tm.tmExternalLeading;

		SetTextColor(hdcChild, RGB(255, 255, 255)); //Textfarbe weiss
		SetBkColor(hdcChild, RGB(0,0,0));


//Koerperinformationen:
		TextOut(hdcChild, rand, rand, schrift, wsprintf(schrift, "Krperinformationen:"));
		
		TextOut(hdcChild, rand*2, rand + 2*cyChar, schrift, wsprintf(schrift, "Radius:"));
		TextOut(hdcChild, rand*2, rand + 3*cyChar, schrift, wsprintf(schrift, "Seitenlnge:"));
		TextOut(hdcChild, rand*2, rand + 4*cyChar, schrift, wsprintf(schrift, "Dimensionen:"));
		TextOut(hdcChild, rand*2, rand + 5*cyChar, schrift, wsprintf(schrift, "Kreisflche:"));

		TextOut(hdcChild, rand*14, rand + 2*cyChar, schrift, wsprintf(schrift, "%i  px          ", koerper.getRadius() ));
		TextOut(hdcChild, rand*14, rand + 3*cyChar, schrift, wsprintf(schrift, "%i  px          ", koerper.getSeiteA() ));
		TextOut(hdcChild, rand*14, rand + 4*cyChar, schrift, wsprintf(schrift, "%i             ", koerper.getDimensionen() ));
		TextOut(hdcChild, rand*14, rand + 5*cyChar, schrift,  sprintf(schrift, "%.3f  px^%i                   ", koerper.getFlaeche(), koerper.getDimensionen() ));

		//zur Monte-Carlo-Simulation:
if(mc.get_obAuto() == false)	//Wenn n nicht ueber Varianz bestimmt...
		TextOut(hdcChild, rand, rand + 7*cyChar, schrift, wsprintf(schrift, "Monte-Carlo-Simulation:    (%i %%)        ", mc.Fortschritt() ));
		//Fortschritt angeben
else	//wenn n ueber Varianz ermittelt wird...
		TextOut(hdcChild, rand, rand + 7*cyChar, schrift, wsprintf(schrift, "Monte-Carlo-Simulation:                   " ));
		//...kann kein Fortschritt berechnet werden.
		
		
		TextOut(hdcChild, rand*2, rand + 9*cyChar, schrift, wsprintf(schrift, "geschossen (n):"));
		TextOut(hdcChild, rand*2, rand + 10*cyChar, schrift, wsprintf(schrift, "getroffen (m):"));
		TextOut(hdcChild, rand*2, rand + 11*cyChar, schrift, wsprintf(schrift, "Wahrscheinl. (p):"));
		TextOut(hdcChild, rand*2, rand + 12*cyChar, schrift, wsprintf(schrift, "Varianz:"));

		TextOut(hdcChild, rand*14, rand + 9*cyChar, schrift, sprintf(schrift, "%.0f              ", mc.get_n() ));
		TextOut(hdcChild, rand*14, rand + 10*cyChar, schrift, sprintf(schrift, "%.0f              ", mc.get_m() ));
		TextOut(hdcChild, rand*14, rand + 11*cyChar, schrift, sprintf(schrift, "%.5f %%           ", mc.get_p() * 100 ));
		TextOut(hdcChild, rand*14, rand + 12*cyChar, schrift, sprintf(schrift, "%.10f              ", mc.getVarianz() ));

//PI:

		TextOut(hdcChild, rand, rand + 14*cyChar, schrift, wsprintf(schrift, "Berechnung von PI:"));
		
		TextOut(hdcChild, rand*2, rand + 16*cyChar, schrift, wsprintf(schrift, "PI = 4 * (m / n)"));
	//Berechnung von PI nur bei 2 Dimensionen moeglich:
if(koerper.getDimensionen() == 2)		
		TextOut(hdcChild, rand*2, rand + 17*cyChar, schrift, sprintf(schrift, "%.15f             ", pi.getPI() ));
else
		TextOut(hdcChild, rand*2, rand + 17*cyChar, schrift, sprintf(schrift, "Berechnung nur bei 2 Dimensionen mglich"));


		EndPaint(hChild, &psChild);
	}

	//Fenster regelmaessig aktualisieren:
	if(messageChild == WM_TIMER)
	{
		if(mc.get_obAuto() == false) //Wenn Varianz nicht aktiv...
		{
			mc.Varianz();			 //...trotzdem berechnen
			mc.Wahrscheinlichkeit(); //...Wahrscheinlichkeit trotzdem berechnen
		}
		pi.calcPI(mc.get_m(), mc.get_n());	//PI berechnen
		koerper.Flaeche(mc.get_p());		//Flaeche ermitteln
		InvalidateRect(hChild, 0, 0);		//neue Werte zeichnen
	}
return DefWindowProc(hChild, messageChild, wParam, lParam);
}