// --- MAIN.H
#ifndef _MAIN_H
#define _MAIN_H

#include "resource.h"	//Ressourcen-Definitionen (Menu, Dialoge..)
#include "koerper.h"	//Koerperklasse
#include "mc.h"			//Klasse zur Monte-Carlo-Simulation
#include "pi.h"
#include "fileout.h"


// --- Definitionen:
#define MAX_COLOR   255			//maximaler Farbwert


// --- Fenster-Daten
LRESULT CALLBACK WndProc  (HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ChildProc(HWND, UINT, WPARAM, LPARAM);	//Statusfenster links
LRESULT CALLBACK KreisProc(HWND, UINT, WPARAM, LPARAM);	//Statusfenster links
HWND hWnd;												//Hauptfenster
HWND hKreis;											//Statusfenster links
HWND hChild;											//Statusfenster links
const char name[]="Monte Carlo";						//Fenstername...
const char ChildName[] = "Statusfenster";
const char KreisName[] = "Schussfenster";
HINSTANCE hInstance;




// --- globale Objekte:
Koerper koerper;
MC		mc;
PI		pi;
Fileout ausgabe;

// --- globale Variablen:
char schrift[300] = "Pvuwe$Fhyoo$5'4#Oowvihr$5775 f|'Kdvmg'Woox}rp.";
	//Zur Ausgabe von Text im Fenster/in MessageBoxes/Dialogen

int a=0; int b=0; int c=0;	//Farbe des zu schiessenden Pixels variiert
int cyChar = 0;				//Hoehe eines Buchstaben

bool obBeenden = false;		//Programm beenden?






// --- Dialogprozeduren:
BOOL CALLBACK DialogProcSettings(HWND hDlgSettings, UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message==WM_INITDIALOG)
	{
		SendMessage(GetDlgItem(hDlgSettings, ID_RADIUS), EM_LIMITTEXT, 5,0);
		SendMessage(GetDlgItem(hDlgSettings, ID_DIMENSIONEN), EM_LIMITTEXT, 2,0);
		
		sprintf(schrift, "%.0f", mc.getNumberOfDots());
		SetDlgItemText(hDlgSettings, ID_NUMBER_OF, schrift);
		
		wsprintf(schrift, "%i", koerper.getDimensionen());
		SetDlgItemText(hDlgSettings, ID_DIMENSIONEN, schrift);

		wsprintf(schrift, "%i", koerper.getRadius());
		SetDlgItemText(hDlgSettings, ID_RADIUS, schrift);

		sprintf(schrift, "%.10f", mc.getEPS() );
		SetDlgItemText(hDlgSettings, ID_EPS, schrift);

		wsprintf(schrift, "%i", mc.getNMIN() );
		SetDlgItemText(hDlgSettings, ID_NMIN, schrift);


		if(mc.get_obAuto()==true)
		{
				EnableWindow(GetDlgItem(hDlgSettings, ID_NUMBER_OF), FALSE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_EPS), TRUE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_NMIN), TRUE);
				SendMessage(GetDlgItem(hDlgSettings, ID_AUTO), BM_SETCHECK, 1,0L);
				SetFocus(GetDlgItem(hDlgSettings, ID_AUTO));
		}
		else
		{
				EnableWindow(GetDlgItem(hDlgSettings, ID_NUMBER_OF), TRUE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_EPS), FALSE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_NMIN), FALSE);
		}

		SetFocus(GetDlgItem(hDlgSettings, ID_NUMBER_OF));
	}

	if(message==WM_COMMAND)
	{
		switch(LOWORD(wParam))
		{
		case(IDOK):
			GetDlgItemText(hDlgSettings, ID_NUMBER_OF, schrift, sizeof(schrift));
			mc.setNumberOfDots(atof(schrift));

			GetDlgItemText(hDlgSettings, ID_DIMENSIONEN, schrift, sizeof(schrift));
			if(atoi(schrift)<1)
			{
				MessageBox(hDlgSettings, "Dimensionen zu klein!\nMindestens 1 Dimension verwenden.", "Fehler: Dimensionen", MB_ICONEXCLAMATION|MB_OK);
				break;
			}
			else
				koerper.setDimensionen(atoi(schrift));


			GetDlgItemText(hDlgSettings, ID_RADIUS, schrift, sizeof(schrift));
			if(atoi(schrift)>32000)
			{
				MessageBox(hDlgSettings, "Radius zu gro!\nRadius darf maximal 32000 betragen.", "Fehler: Radius", MB_ICONEXCLAMATION|MB_OK);
				//...denn rand()-Funktion gibt nur int-Werte zurueck: INT_MAX ca. 32000
				break;
			}
			else
				koerper.setRadius(atoi(schrift));
			
			GetDlgItemText(hDlgSettings, ID_EPS, schrift, sizeof(schrift));
			mc.setEPS(atof(schrift));
			
			GetDlgItemText(hDlgSettings, ID_NMIN, schrift, sizeof(schrift));
			mc.setNMIN(atoi(schrift));


			if(BST_CHECKED!=SendDlgItemMessage(hDlgSettings,ID_AUTO,BM_GETCHECK,0,0))
			{mc.set_obAuto(false);} else {mc.set_obAuto(true);}

		case(IDCANCEL):
			EndDialog(hDlgSettings, 0);
			break;

		case(ID_AUTO):
			if(BST_CHECKED!=SendDlgItemMessage(hDlgSettings,ID_AUTO,BM_GETCHECK,0,0))
			{
				EnableWindow(GetDlgItem(hDlgSettings, ID_NUMBER_OF), TRUE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_EPS), FALSE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_NMIN), FALSE);
			}
			else
			{
				EnableWindow(GetDlgItem(hDlgSettings, ID_NUMBER_OF), FALSE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_EPS), TRUE);
				EnableWindow(GetDlgItem(hDlgSettings, ID_NMIN), TRUE);
			}

		}
	}

	return FALSE;
}




BOOL CALLBACK DialogProcOK(HWND hDlgOK, UINT message, WPARAM wParam, LPARAM lParam)
{

	if(message == WM_INITDIALOG)
	{
		SetFocus(GetDlgItem(hDlgOK, IDOK));
	}

	if(message==WM_COMMAND)
	{
		switch(LOWORD(wParam))
		{
		case(IDOK):
			EndDialog(hDlgOK, 0);
			break;
		}
	}

	return FALSE;
}


#endif