// --- MC.CPP

#include "mc.h"
#include "koerper.h"
#include "pi.h"

#include <stdlib.h>		//random()

#include <math.h>		//pow()
#include <windows.h>	//Systemtime


#define	 ZF 1000		//Zufallsfaktor

MC::MC()
{
	m_m = 0;
	m_n = 0;
	m_p = 0;
	m_varianz = 0;
	m_x = 2;
	m_y = 0;

	m_NumberOfDots = 50000;
	m_obAuto = true;
	m_obMonte = false;

	m_EPS	=	0.000005;	//Abbruchwert fuer Varianz
	m_N_MIN	=	50;			//mindestens n Durchlaeufe (Varianz)

}


int MC::random(int radius)	//Zufallsfunktion
{

	return (rand()%(2*radius))-radius;
}


void MC::ShootPoint(Koerper k)
{
	//Zufaellige Koordinaten ermitteln:
	m_x = random(k.getRadius());
	
	if(k.getDimensionen() > 1)
		m_y = random(k.getRadius());
	else
		m_y = 0;

	//xPosition  +  yPosition  +  zPosition .....
	double temp = (pow(m_x, 2) + pow(m_y, 2));

	for(int i=2; i < k.getDimensionen(); i++)
	{
		temp += pow( random(k.getRadius()), 2);
	}


	//liegt Punkt im Kreis ?
	if (temp <= pow(k.getRadius(), 2))
	{
		m_m++;	//guenstige Faelle um 1 erhoehen
	}

	m_n++;		//Gesamtpunkte um 1 erhoehen
}



void MC::Wahrscheinlichkeit()		//Wahrscheinlichkeit ermitteln
{
	if((m_n > 0)&&(m_m > 0))
	{
		m_p = ( ((double)m_m)/((double)m_n) );
	}
	else
	{
		m_p = 0;
	}
}


void MC::Varianz()					//Varianzberechnung
{
	m_varianz = (m_p - pow(m_p,2)) / (m_n-1);
}


int MC::Fortschritt()	//Fortschritt der Berechnung in Prozent
{
	return (int)( (m_n / m_NumberOfDots) * 100 ); //Anteil an gesamt zu schieenden Punkten
}



void MC::StartMC()
{
	m_m = 0;
	m_n = 0;
	m_p = 0;
	m_varianz = 0;
	m_x = 0;
	m_y = 0;

	m_obMonte = true;
}


void MC::EndMC(PI pi)
{
	m_obMonte = false;
	Wahrscheinlichkeit();
	pi.calcPI(m_m, m_n);
}
