// --- MC.H

#ifndef _MC_H
#define _MC_H

#include "koerper.h"
#include "pi.h"

class MC
{
private:
	double	m_m;	//guenstige Faelle: Punkte im Kreis
	double	m_n;	//moegliche Faelle: alle Punkte
	double	m_p;	//Wahrscheinlichkeit, dass P(x,y) in Kreis

	int		m_x;	//Punktkoordinate X des zu schiessenden Punktes
	int		m_y;	//Punktkoordinate Y ... beide zum Zeichnen benoetigt

	double	m_varianz;  //Inwiefern Wahrscheinlichkeit (p) und Anzahl der Kreise zueinander variieren
	double	m_EPS;		//Abbruchwert fuer Varianz
	int		m_N_MIN;	//mindestens n Durchlaeufe (Varianz)

	bool    m_obAuto;	//Punktanzahl automatisch bestimmen (Varianz) ?
	bool	m_obMonte;	//wird Simulation durchgefuehrt ?

	double	m_NumberOfDots;	//Anzahl zu schiessender Punkte (nur wenn m_obAuto == false)



public:
	MC();

	void	set_m(double m)			{m_m = m;}
	double	get_m()					{return m_m;}

	void	set_n(double n)			{m_n = n;}
	double	get_n()					{return m_n;}

	void	set_p(double p)			{m_p = p;}
	double	get_p()					{return m_p;}

	int		getX()					{return m_x;}
	int		getY()					{return m_y;}

	void	set_obAuto(bool obA)	{m_obAuto = obA;}
	bool	get_obAuto()			{return m_obAuto;}
	void	set_obMonte(bool obM)	{m_obMonte = obM;}
	bool	get_obMonte()			{return m_obMonte;}

	void	setNumberOfDots(double n){m_NumberOfDots = n;}
	double	getNumberOfDots()		{return m_NumberOfDots;}

	double	getVarianz()			{return m_varianz;}
	void	setEPS(double eps)		{m_EPS = eps;}
	double	getEPS()				{return m_EPS;}
	void	setNMIN(int n_min)		{m_N_MIN = n_min;}
	int		getNMIN()				{return m_N_MIN;}

	void	StartMC();
	void	EndMC(PI pi);

	int		random(int radius);	//Zufallsfunktion
	void	ShootPoint(Koerper k);		//Punkt schiessen und pruefen
	void	Wahrscheinlichkeit();		//Wahrscheinlichkeit ermitteln
	void	Varianz();					//Varianzberechnung
	int		Fortschritt();				//Fortschritt der Berechnung in Prozent
};

#endif